OpenCL C++ Bindings: cl::Image Class Reference

OpenCL C++ Bindings

Public Member Functions | Protected Member Functions | List of all members
cl::Image Class Reference

C++ base class for Image Memory objects. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Image:

## Public Member Functions
template<typename T >
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo(). More...
template<cl_image_info name>
detail::param_traits< detail::cl_image_info, name >::param_type | getImageInfo (cl_int *err=NULL) const
| Wrapper for clGetImageInfo() that returns by value. More...
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to NULL. More...
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership. More...
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership. More...
| Memory (const Memory &mem)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Memory & | operator= (const Memory &mem)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Memory (Memory &&mem) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Memory & | operator= (Memory &&mem)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
template<typename T >
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo(). More...
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=NULL) const
| Wrapper for clGetMemObjectInfo() that returns by value. More...
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=NULL)
| Registers a callback function to be called when the memory object is no longer needed. More...
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
| Wrapper (const cl_type &obj, bool retainObject)
| Wrapper (const Wrapper< cl_type > &rhs)
| Wrapper (Wrapper< cl_type > &&rhs) CL_HPP_NOEXCEPT_
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
Wrapper< cl_type > & | operator= (Wrapper< cl_type > &&rhs)
Wrapper< cl_type > & | operator= (const cl_type &rhs)
const cl_type & | operator() () const
cl_type & | operator() ()
cl_type | get () const

## Protected Member Functions
| Image ()
| Default constructor - initializes to NULL. More...
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership. More...
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. More...
| Image (const Image &img)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Image & | operator= (const Image &img)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Image (Image &&img) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Image & | operator= (Image &&img)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

C++ base class for Image Memory objects.

See Memory for details about copy semantics, etc.

See also
  Memory

Definition at line 4434 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Image() [1/4]

cl::Image::Image | ( |  | ) |
| inlineprotected

Default constructor - initializes to NULL.

Definition at line 4438 of file opencl.hpp.

## ◆ Image() [2/4]

cl::Image::Image | ( | const cl_mem & | image,
|  | bool | retainObject = `false`
| ) |  |
| inlineexplicitprotected

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

Definition at line 4447 of file opencl.hpp.

## ◆ Image() [3/4]

cl::Image::Image | ( | const Image & | img | ) |
| inlineprotected

Copy constructor to forward copy to the superclass correctly. Required for MSVC.

Definition at line 4463 of file opencl.hpp.

## ◆ Image() [4/4]

cl::Image::Image | ( | Image && | img | ) |
| inlineprotected

Move constructor to forward move to the superclass correctly. Required for MSVC.

Definition at line 4477 of file opencl.hpp.

## Member Function Documentation

## ◆ getImageInfo() [1/2]

template<typename T >

cl_int cl::Image::getImageInfo | ( | cl_image_info | name,
|  | T * | param
| ) |  | const
| inline

Wrapper for clGetImageInfo().

Definition at line 4492 of file opencl.hpp.

## ◆ getImageInfo() [2/2]

template<cl_image_info name>

detail::param_traits< detail::cl_image_info, name >::param_type cl::Image::getImageInfo | ( | cl_int * | err = `NULL` | ) | const
| inline

Wrapper for clGetImageInfo() that returns by value.

Definition at line 4502 of file opencl.hpp.

## ◆ operator=() [1/3]

Image & cl::Image::operator= | ( | const cl_mem & | rhs | ) |
| inlineprotected

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Definition at line 4454 of file opencl.hpp.

## ◆ operator=() [2/3]

Image & cl::Image::operator= | ( | const Image & | img | ) |
| inlineprotected

Copy assignment to forward copy to the superclass correctly. Required for MSVC.

Definition at line 4468 of file opencl.hpp.

## ◆ operator=() [3/3]

Image & cl::Image::operator= | ( | Image && | img | ) |
| inlineprotected

Move assignment to forward move to the superclass correctly. Required for MSVC.

Definition at line 4482 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp